Skip to content

Empty Data State

Use the EmptyDataState plugin to display a contextual overlay when the grid has no data or all rows are hidden by active filters.

Overview

The Empty Data State plugin provides a user-friendly overlay system for Handsontable when there’s no data to display. It automatically detects when your table is empty or when all data is hidden by filters, and displays an appropriate message with optional action buttons. It automatically integrates with the Filters plugin to provide context-aware messages and actions.

Basic configuration

To enable the Empty Data State plugin, set the emptyDataState option to true or provide a configuration object.

JavaScript
import Handsontable from 'handsontable';
const container = document.getElementById('example1');
new Handsontable(container, {
data: [],
height: 'auto',
colHeaders: true,
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: true,
licenseKey: 'non-commercial-and-evaluation',
});
TypeScript
import Handsontable from 'handsontable';
const container = document.getElementById('example1') as HTMLElement;
new Handsontable(container, {
data: [], // Empty data to trigger empty state
height: 'auto',
colHeaders: true,
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: true, // Enable empty data state with default settings
licenseKey: 'non-commercial-and-evaluation',
});

Custom configuration

The empty data state supports customization of the title, description, and action buttons.

JavaScript
// Custom configuration example for Empty Data State plugin
// This example shows how to customize the empty data state message
import Handsontable from 'handsontable';
const container = document.getElementById('example2');
const hot = new Handsontable(container, {
data: [],
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: {
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
// Add some sample data
hot.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
},
},
licenseKey: 'non-commercial-and-evaluation',
});
TypeScript
// Custom configuration example for Empty Data State plugin
// This example shows how to customize the empty data state message
import Handsontable from 'handsontable';
const container = document.getElementById('example2') as HTMLElement;
const hot = new Handsontable(container, {
data: [], // Empty data to trigger empty state
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: {
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
// Add some sample data
hot.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
},
},
licenseKey: 'non-commercial-and-evaluation',
});

Dynamic messages based on source

You can provide different messages based on the source of the empty state (e.g., filters vs. no data). This allows for more contextual user guidance.

JavaScript
// Dynamic messages based on source example for Empty Data State plugin
// This example shows how to provide different messages based on the source of empty state
import Handsontable from 'handsontable';
const container = document.getElementById('example3');
const hot = new Handsontable(container, {
data: [],
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
contextMenu: true,
emptyDataState: {
message: (source) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = hot.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
},
},
],
};
default:
return {
title: 'No data available',
description: "There's nothing to display yet. Add some data to get started.",
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hot.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
};
}
},
},
licenseKey: 'non-commercial-and-evaluation',
});
TypeScript
// Dynamic messages based on source example for Empty Data State plugin
// This example shows how to provide different messages based on the source of empty state
import Handsontable from 'handsontable';
const container = document.getElementById('example3') as HTMLElement;
const hot = new Handsontable(container, {
data: [],
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
contextMenu: true,
emptyDataState: {
message: (source: string) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = hot.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
},
},
],
};
default:
return {
title: 'No data available',
description: "There's nothing to display yet. Add some data to get started.",
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hot.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
};
}
},
},
licenseKey: 'non-commercial-and-evaluation',
});

Localize empty data state

Translate default empty data state labels using the global translations mechanism. The empty data state plugin introduces the following keys to the language dictionary that you can use to translate the empty state UI:

KeyDefault Value
EMPTY_DATA_STATE_TITLE'No data available'
EMPTY_DATA_STATE_DESCRIPTION'There's nothing to display yet.'
EMPTY_DATA_STATE_TITLE_FILTERS'No results found'
EMPTY_DATA_STATE_DESCRIPTION_FILTERS'It looks like your current filters are hiding all results.'
EMPTY_DATA_STATE_BUTTONS_FILTERS_RESET'Reset filters'

To learn more about the translation mechanism, see the Languages guide.

Result

After enabling the plugin, the grid displays a centered overlay message whenever there is no data to show. When the Filters plugin is also enabled, the overlay automatically switches to a filter-specific message and shows a “Reset filters” button when all rows are hidden by active filter conditions.

Skip to content

Empty Data State

Use the EmptyDataState plugin to display a contextual overlay when the grid has no data or all rows are hidden by active filters.

Overview

The Empty Data State plugin provides a user-friendly overlay system for Handsontable when there’s no data to display. It automatically detects when your table is empty or when all data is hidden by filters, and displays an appropriate message with optional action buttons. It automatically integrates with the Filters plugin to provide context-aware messages and actions.

Basic configuration

To enable the Empty Data State plugin, set the emptyDataState option to true or provide a configuration object.

TypeScript
/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings, HotTableModule } from '@handsontable/angular-wrapper';
@Component({
selector: 'app-example1',
standalone: true,
imports: [HotTableModule],
template: `
<hot-table
[settings]="hotSettings"
[data]="hotData"
>
</hot-table>
`,
})
export class AppComponent {
readonly hotData = [];
readonly hotSettings: GridSettings = {
height: 'auto',
colHeaders: true,
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: true, // Enable empty data state with default settings
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<app-example1></app-example1>

Custom configuration

The empty data state supports customization of the title, description, and action buttons.

TypeScript
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule } from '@handsontable/angular-wrapper';
@Component({
selector: 'app-example2',
standalone: true,
imports: [HotTableModule],
template: `
<hot-table
#hotTable
[settings]="hotSettings"
[data]="hotData"
>
</hot-table>
`,
})
export class AppComponent {
@ViewChild('hotTable') hotTable!: HotTableComponent;
readonly hotData = [];
readonly hotSettings: GridSettings = {
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: {
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
this.hotTable.hotInstance!.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
}
}
]
}
},
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<app-example2></app-example2>

Dynamic messages based on source

You can provide different messages based on the source of the empty state (e.g., filters vs. no data). This allows for more contextual user guidance.

TypeScript
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule } from '@handsontable/angular-wrapper';
@Component({
selector: 'app-example3',
standalone: true,
imports: [HotTableModule],
template: `
<hot-table
#hotTable
[settings]="hotSettings"
[data]="hotData"
>
</hot-table>
`,
})
export class AppComponent {
@ViewChild('hotTable') hotTable!: HotTableComponent;
readonly hotData = [];
readonly hotSettings: GridSettings = {
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
contextMenu: true,
emptyDataState: {
message: (source: string) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = this.hotTable.hotInstance!.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
}
}
]
};
default:
return {
title: 'No data available',
description: 'There\'s nothing to display yet. Add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
this.hotTable.hotInstance!.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
}
}
]
};
}
}
},
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
// register Handsontable's modules
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<app-example3></app-example3>

Localize empty data state

Translate default empty data state labels using the global translations mechanism. The empty data state plugin introduces the following keys to the language dictionary that you can use to translate the empty state UI:

KeyDefault Value
EMPTY_DATA_STATE_TITLE'No data available'
EMPTY_DATA_STATE_DESCRIPTION'There's nothing to display yet.'
EMPTY_DATA_STATE_TITLE_FILTERS'No results found'
EMPTY_DATA_STATE_DESCRIPTION_FILTERS'It looks like your current filters are hiding all results.'
EMPTY_DATA_STATE_BUTTONS_FILTERS_RESET'Reset filters'

To learn more about the translation mechanism, see the Languages guide.

Result

After enabling the plugin, the grid displays a centered overlay message whenever there is no data to show. When the Filters plugin is also enabled, the overlay automatically switches to a filter-specific message and shows a “Reset filters” button when all rows are hidden by active filter conditions.

Skip to content

Empty Data State

Use the EmptyDataState plugin to display a contextual overlay when the grid has no data or all rows are hidden by active filters.

Overview

The Empty Data State plugin provides a user-friendly overlay system for Handsontable when there’s no data to display. It automatically detects when your table is empty or when all data is hidden by filters, and displays an appropriate message with optional action buttons. It automatically integrates with the Filters plugin to provide context-aware messages and actions.

Basic configuration

To enable the Empty Data State plugin, set the emptyDataState option to true or provide a configuration object.

JavaScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={true}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
emptyDataState={true} // Enable empty data state with default settings
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;
TypeScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={true}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
emptyDataState={true} // Enable empty data state with default settings
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;

Custom configuration

The empty data state supports customization of the title, description, and action buttons.

JavaScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={['First Name', 'Last Name', 'Email']}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
emptyDataState={{
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
// Add some sample data
hotTableRef.current?.hotInstance.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
},
}}
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;
TypeScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={['First Name', 'Last Name', 'Email']}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
emptyDataState={{
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
// Add some sample data
hotTableRef.current?.hotInstance.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
},
}}
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;

Dynamic messages based on source

You can provide different messages based on the source of the empty state (e.g., filters vs. no data). This allows for more contextual user guidance.

JavaScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={['First Name', 'Last Name', 'Email']}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
contextMenu={true}
emptyDataState={{
message: (source) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = hotTableRef.current?.hotInstance.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
},
},
],
};
default:
return {
title: 'No data available',
description: "There's nothing to display yet. Add some data to get started.",
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hotTableRef.current?.hotInstance.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
};
}
},
}}
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;
TypeScript
import React, { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const ExampleComponent = () => {
const hotTableRef = useRef(null);
return (
<HotTable
ref={hotTableRef}
data={[]} // Empty data to trigger empty state
height="auto"
colHeaders={['First Name', 'Last Name', 'Email']}
rowHeaders={true}
navigableHeaders={true}
dropdownMenu={true}
filters={true}
contextMenu={true}
emptyDataState={{
message: (source) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = hotTableRef.current?.hotInstance.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
},
},
],
};
default:
return {
title: 'No data available',
description: "There's nothing to display yet. Add some data to get started.",
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hotTableRef.current?.hotInstance.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
};
}
},
}}
licenseKey="non-commercial-and-evaluation"
/>
);
};
export default ExampleComponent;

Localize empty data state

Translate default empty data state labels using the global translations mechanism. The empty data state plugin introduces the following keys to the language dictionary that you can use to translate the empty state UI:

KeyDefault Value
EMPTY_DATA_STATE_TITLE'No data available'
EMPTY_DATA_STATE_DESCRIPTION'There's nothing to display yet.'
EMPTY_DATA_STATE_TITLE_FILTERS'No results found'
EMPTY_DATA_STATE_DESCRIPTION_FILTERS'It looks like your current filters are hiding all results.'
EMPTY_DATA_STATE_BUTTONS_FILTERS_RESET'Reset filters'

To learn more about the translation mechanism, see the Languages guide.

Result

After enabling the plugin, the grid displays a centered overlay message whenever there is no data to show. When the Filters plugin is also enabled, the overlay automatically switches to a filter-specific message and shows a “Reset filters” button when all rows are hidden by active filter conditions.

Skip to content

Empty Data State

Use the EmptyDataState plugin to display a contextual overlay when the grid has no data or all rows are hidden by active filters.

Overview

The Empty Data State plugin provides a user-friendly overlay system for Handsontable when there’s no data to display. It automatically detects when your table is empty or when all data is hidden by filters, and displays an appropriate message with optional action buttons. It automatically integrates with the Filters plugin to provide context-aware messages and actions.

Basic configuration

To enable the Empty Data State plugin, set the emptyDataState option to true or provide a configuration object.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
data: [],
height: 'auto',
colHeaders: true,
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Custom configuration

The empty data state supports customization of the title, description, and action buttons.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const hotSettings = ref<GridSettings>({
data: [],
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
emptyDataState: {
message: {
title: 'No data available',
description: 'Please add some data to get started.',
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hotRef.value?.hotInstance?.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
},
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example2">
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Dynamic messages based on source

You can provide different messages based on the source of the empty state (e.g., filters vs. no data). This allows for more contextual user guidance.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const hotSettings = ref<GridSettings>({
data: [],
height: 'auto',
colHeaders: ['First Name', 'Last Name', 'Email'],
rowHeaders: true,
navigableHeaders: true,
dropdownMenu: true,
filters: true,
contextMenu: true,
emptyDataState: {
message: (source) => {
switch (source) {
case 'filters':
return {
title: 'No results found',
description: 'Your current filters are hiding all results. Try adjusting your search criteria.',
buttons: [
{
text: 'Clear Filters',
type: 'secondary',
callback: () => {
const filtersPlugin = hotRef.value?.hotInstance?.getPlugin('filters');
if (filtersPlugin) {
filtersPlugin.clearConditions();
filtersPlugin.filter();
}
},
},
],
};
default:
return {
title: 'No data available',
description: "There's nothing to display yet. Add some data to get started.",
buttons: [
{
text: 'Add Sample Data',
type: 'primary',
callback: () => {
hotRef.value?.hotInstance?.loadData([
['John', 'Doe', 'john@example.com'],
['Jane', 'Smith', 'jane@example.com'],
['Bob', 'Johnson', 'bob@example.com'],
['Alice', 'Johnson', 'alice@example.com'],
]);
},
},
],
};
}
},
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example3">
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Localize empty data state

Translate default empty data state labels using the global translations mechanism. The empty data state plugin introduces the following keys to the language dictionary that you can use to translate the empty state UI:

KeyDefault Value
EMPTY_DATA_STATE_TITLE'No data available'
EMPTY_DATA_STATE_DESCRIPTION'There's nothing to display yet.'
EMPTY_DATA_STATE_TITLE_FILTERS'No results found'
EMPTY_DATA_STATE_DESCRIPTION_FILTERS'It looks like your current filters are hiding all results.'
EMPTY_DATA_STATE_BUTTONS_FILTERS_RESET'Reset filters'

To learn more about the translation mechanism, see the Languages guide.

Result

After enabling the plugin, the grid displays a centered overlay message whenever there is no data to show. When the Filters plugin is also enabled, the overlay automatically switches to a filter-specific message and shows a “Reset filters” button when all rows are hidden by active filter conditions.